//*****************************************
// AT mega328P-PU(28pin 300mil SDIP) one IN-14 Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:mega_spi.c
//
//  PB2(SS)  : SPI-SS
//  PB3(MOSI): SPI-MOSI(Mega328:out, DS3234:in)
//  PB4(MISO): SPI-MISO(Mega328:in,  DS3234:out)
//  PB5(SCT) : SPI-SCK
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2017/11/18 New  Taishi
//*****************************************

#include	<avr/io.h>

#include	"one_in14_clock.h"
#include	"port_bit.h"
#include	"mega_spi.h"


// ************************************
// SPI ݒ
//   @Ȃ
//  ߂l Ȃ
// ************************************
void	spi_init(void)
{
	// |[gݒ
	PORTB |= (1 << PB2);								// SS=H
	DDRB  |= ((1 << DDB2) | (1 << DDB3) | (1 << DDB5));	// SS,MOSI,SCK o͂ɂ
	DDRB  &= ~(1 << DDB4);								// MISO ͂ɂ

	// rohݒ
	PRR &= ~(1 << PRSPI);																		// SPIғ
	SPCR = ((1 << SPE) | (1 << MSTR) | (1 << CPOL) | (1 << CPHA) | (1 << SPR1) | (0 << SPR0));	// spiғA}X^[A[hRAfosc/64 = 125kHz
	SPSR = (0 << SPI2X);																		// fosc/64 = 125kHz

}

// ************************************
// SPI Jn
//     Ȃ
//  ߂l Ȃ
//
// ************************************
void	spi_start(void)
{
	PORTB &= ~(1 << PB2);								// SS=L
}

// ************************************
// SPI ~
//     Ȃ
//  ߂l Ȃ
//
// ************************************
void spi_stop(void)
{
	PORTB |= (1 << PB2);								// SS=H
}

// ************************************
// SPI ǂݏ
//     data: ݃f[^
//  ߂lFǏof[^
//
// ************************************
unsigned char	spi_rd_wr(unsigned char data)
{
	SPDR = data;							// ݃f[^ f[^WX^ɃZbg
	while ((SPSR & (1 << SPIF)) == 0){		// SPIF PɂȂ܂ő҂
		;
	}
	return(SPDR);
}
