//*****************************************
// AT mega328P-PU(28pin 300mil SDIP) one IN-14 Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:one_in14_clock.c
//
//  4̂hm|PSv1쐬
//
//
//  2017/11/18 New  Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"one_in14_clock.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"ad_conv.h"
#include	"nixie.h"
#include	"rtc_ds3234.h"
#include	"set_rtc.h"

static	unsigned char	run=0;
static	unsigned char	dc_match=0;
static	int				bef1_ad_ave=0;
static	unsigned char	renzoku[16]={0,1,2,3,9,8,7,4,5,6,15,15,15,15,15,15};			// ̑w̑w

unsigned char			gDisp_count = 0;


//***************************
// f[^o͑삷
//***************************
void	output_data(void)
{
	if(run == 0){					// nee̎
		pulse_out = PULSE_OUT_MAX;
		run = 1;					// nm
	}else{							// nm̎
		pulse_out = 0;
		run = 0;					// nee
	}
}
//***************************
// `^c̒lłnmpXω
//  `^cl ad6_ave ɂ
//  pX pulse_out ɓ
//***************************
void	feed_back_pro(void)
{
	int		p;
	int		ad_ave;
	int		nxt_ad_ave;
	int		sa;

#if	AD_NO == 6
	ad_ave = ad6_ave;
#else
 #if	AD_NO == 5
	ad_ave = ad5_ave;
 #else
	ad_ave = ad0_ave;
 #endif
#endif

	p = pulse_out;
	sa = ad_ave - bef1_ad_ave;
	if(0 < sa){											// o̎
		nxt_ad_ave = ad_ave + sa + sa;					// \l傫
	}else{
		nxt_ad_ave = ad_ave + sa;
	}

	if (ad_ave == LEVEL_AD){							// ڕWl̎
		;
	}else if (ad_ave < LEVEL_AD){						// ܂Ⴂ
		if(LEVEL_AD_L <= ad_ave){						// ڕWlɗƍl
			p += OUT_BAND;								// ۂ͉Ȃ
		}else if(LEVEL_AD_NL <= nxt_ad_ave){			// ڕWlɖwǋ߂Âƍl
			p += OUT_NEAR;								// ω
		}else if(LEVEL_AD_ML <= nxt_ad_ave){			// ڕWlɑ啪߂Âƍl
			p += OUT_MID;								// ω
		}else if(nxt_ad_ave < LEVEL_AD_ML){				// ڕWlɉƍl
			p += OUT_FAR;								// 傫ω
		}
	}else if (LEVEL_AD < ad_ave){						// ܂
		if(ad_ave <= LEVEL_AD_H){						// ڕWlɗƍl
			p -= OUT_BAND;								// ۂ͉Ȃ
		}else if(nxt_ad_ave <= LEVEL_AD_NH){			// ڕWlɖwǋ߂Âƍl
			p -= OUT_NEAR;								// ω
		}else if(nxt_ad_ave <= LEVEL_AD_MH){			// ڕWlɑ啪߂Âƍl
			p -= OUT_MID;								// ω
		}else if(LEVEL_AD_MH < nxt_ad_ave){				// ڕWlɉƍl
			p -= OUT_FAR;								// 傫ω
		}
	}

	if(p < PULSE_OUT_MIN){
		p = PULSE_OUT_MIN;
	}else if(PULSE_OUT_MAX < p){
		p = PULSE_OUT_MAX;
	}

	if((LEVEL_AD - 200) < nxt_ad_ave){						// QOOO̎
		if(25 < sa){										// ωʂRT𒴂Ă鎞
			p = 200;
		}
	}

	pulse_out = p;

	if((LEVEL_LED_L <= ad_ave)&&(ad_ave <= LEVEL_LED_H)){	// kdc_͈͂ɗƍl
		dc_match=1;
	}else{
		dc_match=0;
	}

	bef1_ad_ave = ad_ave;
}

//***************************
// QOOuۂ
//***************************
void	stabilizer_200v(void)
{
	if(tim_10ms_ad == 0){
		tim_10ms_ad = 10;									// 100mS Ԋuł`^cf[^擾

#if	AD_NO == 6
		ad6_get_data();										//  A/D l̎擾
#else
 #if	AD_NO == 5
		ad5_get_data();										//  A/D l̎擾
 #else
		ad0_get_data();										//  A/D l̎擾
 #endif
#endif

		feed_back_pro();
		set_timer1_ontime();
		if(dc_match==1){
			led_on();										// LED ON
			dynamic_nixie_active(1);
		}else{
			led_off();										// LED OFF
		}
	}
}

//***************************
// `FbNs
//***************************
void	check(void)
{
	unsigned char	uc;
	unsigned char	old_run = 0;
	unsigned char	kazu = 0;
	unsigned char	pause = 0;

	delay_ms(500);									// 500mS Delay
	led_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_off();										// LED OFF

	get_sw();

	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	old_run = run;
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	bef1_ad_ave = 0;
	output_data();									// f[^o͑삷
	led_off();										// LED OFF
	pulse_on();
	tim_10ms_ad = 0;

	for(;;){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ

		if(uc == SW_OFF_SHORT){									// XCb`NbNꂽ
			pause ^= 1;
		}

		if(tim_10ms_blink == 0){
			tim_10ms_blink = 100;								// 1000mS Ԋu
			if(pause == 0){
				disp_dynamic_nixie_dot(NIXE_DOT_OFF);			// _
				if(kazu == 10){
					disp_dynamic_nixie_dot(NIXE_DOT_L_ON);		// _
					disp_dynamic_nixie_number(15,15);			// 
					disp_dynamic_nixie_ratio(DISP_RATE_MAX);
				}else if(kazu == 11){
					disp_dynamic_nixie_dot(NIXE_DOT_R_ON);		// E_
					disp_dynamic_nixie_number(15,15);			// 
					disp_dynamic_nixie_ratio(DISP_RATE_MAX);
				}else{
					disp_dynamic_nixie_number(kazu,kazu);		// 
					disp_dynamic_nixie_ratio(DISP_RATE_MAX);
				}
				kazu++;
				if(11 < kazu){									// Oɖ߂
					kazu = 0;
				}
			}
		}
		stabilizer_200v();										// QOOuۂ
	}

}
//***************************
//  Pp Main
//    ݂̂̕\
//***************************
static	void	main_1keta(void)
{
	unsigned char	uc;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	anime_no = 0;
	char			disp_rate = DISP_RATE_MAX;
	unsigned char	first = 1;

	sei();											// 荞݉

	bef1_ad_ave = 0;
	pulse_out = PULSE_OUT_MAX;
	pulse_on();										// 200V Output Start

	tim_10ms_nixie = 0;

	while(1){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ
		if(uc == SW_OFF_LONG){									// ꂽ
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			disp_clock_mode = HM;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
			first = 1;
		}else{
			if(rtc_1s_flg != old_rtc_1s_flg){					// qsbĂ鎞̂Pboߗp
				old_rtc_1s_flg = rtc_1s_flg;
				rtc_read();										// RTC ǂݏo
				if(first != 0){
					gDisp_count = (gRTC_sec % 5);
					first = 0;
				}
				if(gRTC_sec == 0){
					gDisp_count = 0;
					if(gRTC_min == 0){								// ̎
						disp_clock_mode = ANIME;
						tim_10ms_nixie = 0;
						anime_no = 0;
					}
				}
				if(disp_clock_mode == HM){							// [h
					disp_clock_mode = HM;							// \[h
					if(gDisp_count == 0){											// OԖ
						disp_dynamic_nixie_number(gRTC_hou >> 4, gRTC_hou >> 4);	// ̏
						disp_rate = DISP_RATE_MAX;
						disp_dynamic_nixie_ratio(disp_rate);
						disp_dynamic_nixie_dot(NIXE_DOT_OFF);						// Ehbg\
					}else if(gDisp_count == 1){										// PԖ
						disp_dynamic_nixie_number(gRTC_hou & 0x0f, gRTC_hou & 0x0f);	// ̉
						disp_rate = DISP_RATE_MAX;
						disp_dynamic_nixie_ratio(disp_rate);
						disp_dynamic_nixie_dot(NIXE_DOT_L_ON);						// hbg\
					}else if(gDisp_count == 2){										// QԖ
						disp_dynamic_nixie_number(gRTC_min >> 4, gRTC_min >> 4);	// ̏
						disp_rate = DISP_RATE_MAX;
						disp_dynamic_nixie_ratio(disp_rate);
						disp_dynamic_nixie_dot(NIXE_DOT_R_ON);						// Ehbg\
					}else if(gDisp_count == 3){										// RԖ
						disp_dynamic_nixie_number(gRTC_min & 0x0f, gRTC_min & 0x0f);				// ̉
						disp_rate = DISP_RATE_MAX;
						disp_dynamic_nixie_ratio(disp_rate);
						disp_dynamic_nixie_dot(NIXE_DOT_L_ON | NIXE_DOT_R_ON);		// Ehbg\
					}else if(gDisp_count == 4){										// SԖ
						disp_dynamic_nixie_number(15, 15);							// \Ȃ
						disp_rate = DISP_RATE_MAX;
						disp_dynamic_nixie_ratio(disp_rate);
						disp_dynamic_nixie_dot(NIXE_DOT_L_ON | NIXE_DOT_R_ON);		// Ehbg\
					}

					gDisp_count++;
					if (4 < gDisp_count){
						gDisp_count = 0;
					}
				}
			}

			if(tim_10ms_nixie == 0){								// QOO
				if(disp_clock_mode == ANIME){						// Aj[V̎
					tim_10ms_nixie = 20;							// QOOr^C}[d|
					disp_dynamic_nixie_number(renzoku[anime_no],renzoku[anime_no]);	// Aj
					disp_dynamic_nixie_ratio(DISP_RATE_MAX);
					anime_no++;
					if(9 < anime_no){
						disp_clock_mode = HM;						// \ɖ߂
						first = 1;
					}
				}
			}
		}

		stabilizer_200v();										// QOOuۂ
	}
}

//***************************
//  Main
//***************************
int	main(void)
{

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0) | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, Timer0, Timer1, Timer2, ADC ~
	delay_ms(200);									// 200mS Delay
	MCUCR &= ~(1 << PUD);							// S̃vAbviÖׁj

	init_nixe();									// Nixe\ 
	sw_init();										// XCb`֌W̏ݒ
	rtc_init();										// qsb̏ݒ
	led_init();										// kdc֌W̏ݒ
	timer1_init();									// Timer1 Initial
	timer2_init();									// Timer2 Initial

#if	AD_NO == 6
	ad6_init();										// A/D 6 Initial
#else
 #if	AD_NO == 5
	ad5_init();										// A/D 5 Initial
 #else
	ad0_init();										// A/D 0 Initial
 #endif
#endif

	led_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_off();										// LED OFF

	if((PIND & SW_ON_BIT) == 0){					// XCb`f[^Ă
		check();									// `FbNs
	}

	main_1keta();									// Pp Main

}
