//*****************************************
// AT mega328P-PU(28pin 300mil SDIP) one IN-14 Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:set_rtc_4keta.c
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2017/11/18 New  Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"one_in14_clock.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"rtc_ds3234.h"
#include	"nixie.h"
#include	"set_rtc_1keta.h"


//*****************************************
// ʍ킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_hour_h_1keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ho;
	unsigned char	uc;
	unsigned char	r=0;

	ho = (gRTC_hou >> 4);
	disp_dynamic_nixie_number(ho,ho);				//  ʕ\
	disp_dynamic_nixie_ratio(DISP_RATE_MAX);
	disp_dynamic_nixie_dot(NIXE_DOT_OFF);			// Ehbgnee

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_action_sw();						// XCb`Ԃ
		uc &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((uc & SW_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				disp_dynamic_nixie_number(15,15);	// uN ʕ\
			}else{
				blk_stat = 0;
				disp_dynamic_nixie_number(ho,10);	//  ʕ\
			}
		}

		if(uc != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc & SW_ON_CONTINUE) != 0){			// ꑱ
				ho++;
				if(2 < ho){
					ho = 0;
				}
			}else if((uc & SW_OFF_SHORT) != 0){		// Zꂽ
				if((gRTC_hou >> 4) == ho){			// lύXĂȂ
					;
				}else{
					gRTC_hou &= 0x0f;
					gRTC_hou |= (ho << 4);
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
		stabilizer_200v();							// QOOuۂ
	}

	disp_dynamic_nixie_dot(NIXE_DOT_OFF);			// hbgnee

	return(r);
}
//*****************************************
// ʍ킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_hour_l_1keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ho;
	unsigned char	uc;
	unsigned char	r=0;

	ho = (gRTC_hou & 0x0f);
	disp_dynamic_nixie_number(ho,ho);				//  ʕ\
	disp_dynamic_nixie_ratio(DISP_RATE_MAX);
	disp_dynamic_nixie_dot(NIXE_DOT_L_ON);			// hbgnm

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_action_sw();						// XCb`Ԃ
		uc &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((uc & SW_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				disp_dynamic_nixie_number(15,15);	// uN ʕ\
			}else{
				blk_stat = 0;
				disp_dynamic_nixie_number(ho,ho);	//  ʕ\
			}
		}

		if(uc != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc & SW_ON_CONTINUE) != 0){			// ꑱ
				ho++;
				if((gRTC_hou >> 4) == 2){			// QO̎
					if(3 < ho){
						ho = 0;
					}
				}else{
					if(9 < ho){
						ho = 0;
					}
				}
			}else if((uc & SW_OFF_SHORT) != 0){		// Zꂽ
				if((gRTC_hou & 0x0f) == ho){		// lύXĂȂ
					;
				}else{
					gRTC_hou &= 0xf0;
					gRTC_hou |= ho;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
		stabilizer_200v();							// QOOuۂ
	}

	disp_dynamic_nixie_dot(NIXE_DOT_OFF);			// hbgnee

	return(r);
}
//*****************************************
// ʍ킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_minute_h_1keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mi;
	unsigned char	uc;
	unsigned char	r=0;

	mi = (gRTC_min >> 4);
	disp_dynamic_nixie_number(mi,mi);						//  ʕ\
	disp_dynamic_nixie_ratio(DISP_RATE_MAX);
	disp_dynamic_nixie_dot(NIXE_DOT_R_ON);			// Ehbgnm

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_action_sw();						// XCb`Ԃ
		uc &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((uc & SW_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				disp_dynamic_nixie_number(15,15);		// uN \
			}else{
				blk_stat = 0;
				disp_dynamic_nixie_number(mi,mi);		//  ʕ\
			}
		}

		if(uc != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc & SW_ON_CONTINUE) != 0){			// ꑱ
				mi++;
				if(5 < mi){
					mi = 0;
				}
			}else if((uc & SW_OFF_SHORT) != 0){		// Zꂽ
				if((gRTC_min >> 4) == mi){			// lύXĂȂ
					;
				}else{
					gRTC_min &= 0x0f;
					gRTC_min |= (mi << 4);
					gRTC_sec = 0;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
		stabilizer_200v();							// QOOuۂ
	}

	disp_dynamic_nixie_dot(NIXE_DOT_OFF);			// hbgnee

	return(r);
}
//*****************************************
// ʍ킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_minute_l_1keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mi;
	unsigned char	uc;
	unsigned char	r=0;

	mi = (gRTC_min & 0x0f);
	disp_dynamic_nixie_number(mi,mi);				//  ʕ\
	disp_dynamic_nixie_ratio(DISP_RATE_MAX);
	disp_dynamic_nixie_dot(NIXE_DOT_L_ON | NIXE_DOT_R_ON);	// Ehbgnm

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_action_sw();						// XCb`Ԃ
		uc &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((uc & SW_ON) == 0)){	// ꂢȂ ł̎
				blk_stat = 1;
				disp_dynamic_nixie_number(15,15);	// uN \
			}else{
				blk_stat = 0;
				disp_dynamic_nixie_number(mi,mi);	//  ʕ\
			}
		}

		if(uc != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc & SW_ON_CONTINUE) != 0){			// ꑱ
				mi++;
				if(9 < mi){
					mi = 0;
				}
			}else if((uc & SW_OFF_SHORT) != 0){		// Zꂽ
				if((gRTC_min & 0x0f) == mi){		// lύXĂȂ
					;
				}else{
					gRTC_min &= 0xf0;
					gRTC_min |= mi;
					gRTC_sec = 0;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
		stabilizer_200v();							// QOOuۂ
	}

	disp_dynamic_nixie_dot(NIXE_DOT_OFF);			// hbgnee

	return(r);
}
//*****************************************
// Pv킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
// @̊֐ł QOOũtB[hobN͊|ĂȂ
// @@ԂẐł̂܂܂ŗǂƂ
//*****************************************
unsigned char	proc_set_rtc_1keta(void)
{
	unsigned char	r = 0;

	r = proc_set_hour_h_1keta();				// ʎ킹
	if(r == 0){
		r = proc_set_hour_l_1keta();			// ʎ킹
		if(r == 0){
			r = proc_set_minute_h_1keta();		// ʕ킹
			if(r == 0){
				r = proc_set_minute_l_1keta();	// ʕ킹
			}
		}
	}

	return(r);
}

